## libopenhmd 0.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(openhmd C CXX)
set(CMAKE_C_FLAGS "-std=c99")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")
include_directories(${CMAKE_CURRENT_LIST_DIR}/include)

if (MSVC)
  # Add the "lib" prefix for generated .lib outputs.
  set(LIB_PREFIX lib)
else (MSVC)
  # When building with "make", "lib" prefix will be added automatically by
  # the build tool.
  set(LIB_PREFIX)
endif (MSVC)

#source files set just for Android
set(openhmd_source_files
	${CMAKE_CURRENT_LIST_DIR}/src/openhmd.c
	${CMAKE_CURRENT_LIST_DIR}/src/platform-win32.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_dummy/dummy.c
	${CMAKE_CURRENT_LIST_DIR}/src/omath.c
	${CMAKE_CURRENT_LIST_DIR}/src/platform-posix.c
	${CMAKE_CURRENT_LIST_DIR}/src/fusion.c
)

OPTION(OPENHMD_DRIVER_OCULUS_RIFT "Oculus Rift DK1 and DK2" ON)
OPTION(OPENHMD_DRIVER_EXTERNAL "External sensor driver" ON)
OPTION(OPENHMD_DRIVER_ANDROID "General Android driver" OFF)

if(OPENHMD_DRIVER_OCULUS_RIFT)
	set(openhmd_source_files ${openhmd_source_files} 
	${CMAKE_CURRENT_LIST_DIR}/src/drv_oculus_rift/rift.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_oculus_rift/packet.c
	)
	add_definitions(-DDRIVER_OCULUS_RIFT)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_OCULUS_RIFT)

if (OPENHMD_DRIVER_EXTERNAL)
	set(openhmd_source_files ${openhmd_source_files} 
	${CMAKE_CURRENT_LIST_DIR}/src/drv_external/external.c
	)
	add_definitions(-DDRIVER_EXTERNAL)
endif(OPENHMD_DRIVER_EXTERNAL)

if (OPENHMD_DRIVER_ANDROID)
	set(openhmd_source_files ${openhmd_source_files} 
	${CMAKE_CURRENT_LIST_DIR}/src/drv_android/android.c
	)
	add_definitions(-DDRIVER_ANDROID)
endif(OPENHMD_DRIVER_ANDROID)

add_library(openhmd ${openhmd_source_files} ${LIBS})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_DIR}/)

=== debian/changelog ===
libopenhmd (0.2.0-5) unstable; urgency=medium

  * ITA package. Closes (#912303)
  * d/control: update Maintainer field
  * d/control: update Standards-Version field. Update to 4.2.1
  * d/compat: update from 9 to 11
  * d/copyright: update the debian files copyright field

 -- Emmanuel Arias <emmanuelarias30@gmail.com>  Sat, 01 Dec 2018 23:09:08 -0300

libopenhmd (0.2.0-4) unstable; urgency=medium

  [ Simon McVittie ]
  * d/tests/build: Add a simple compile/link/execute test
  * Make libopenhmd-dev depend on libhidapi-dev so the pkg-config
    metadata will work (Closes: #911258)
  * d/p/Autoconf-do-not-hard-code-the-hidapi-dependency-in-the-pk.patch,
    d/p/pkg-config-Substitute-the-correct-libdir-includedir.patch:
    Further fixes to the pkg-config metadata

  [ Balint Reczey ]
  * debian/control: Point Vcs-* to Salsa.
    Thanks to Simon McVittie for migrating the repository

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 29 Oct 2018 21:44:08 +0100

libopenhmd (0.2.0-3) unstable; urgency=medium

  * Fix filename in debian/watch
  * Pass -lpthread in LDFLAGS on kfreebsd-* (Closes: #845684)

 -- Balint Reczey <balint@balintreczey.hu>  Mon, 12 Dec 2016 21:14:31 +0100

libopenhmd (0.2.0-2) unstable; urgency=medium

  * Build-depend on libsdl1.2-dev instead of libsdl2-dev

 -- Balint Reczey <balint@balintreczey.hu>  Fri, 25 Nov 2016 19:56:45 +0100

libopenhmd (0.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #845272)

 -- Balint Reczey <balint@balintreczey.hu>  Mon, 21 Nov 2016 23:01:25 +0000

=== debian/control ===
Source: libopenhmd
Maintainer: Emmanuel Arias <emmanuelarias30@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11),
               libgl1-mesa-dev | libgl-dev,
               libglew-dev,
               libhidapi-dev,
               libsdl1.2-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian/libopenhmd
Vcs-Git: https://salsa.debian.org/debian/libopenhmd.git -b master
Homepage: http://openhmd.net/

Package: libopenhmd0
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: API and drivers for immersive technology (shared library)
 OpenHMD aims to provide a Free and Open Source API and drivers for
 immersive technology, such as head mounted displays with built in head
 tracking.
 .
 This package provides the shared library.

Package: libopenhmd-dev
Architecture: any
Section: libdevel
Depends: libhidapi-dev,
         libopenhmd0 (= ${binary:Version}),
         ${misc:Depends}
Description: API and drivers for immersive technology (development files)
 OpenHMD aims to provide a Free and Open Source API and drivers for
 immersive technology, such as head mounted displays with built in head
 tracking.
 .
 This package provides the necessary files needed for development.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# libopenhmd.so uses sincosf and friends
DEB_LDFLAGS_MAINT_APPEND = -lm

# fix FTBFS on kfreebsd-*
ifneq (,$(findstring kfreebsd,$(DEB_HOST_ARCH)))
DEB_LDFLAGS_MAINT_APPEND += -lpthread
endif

export DEB_LDFLAGS_MAINT_APPEND

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-openglexample

## libopenhmd 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(openhmd C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(LIB_VERSION_MAJOR 0)
set(LIB_VERSION_MINOR 1)
set(LIB_VERSION_PATCH 0)
set(LIB_VERSION_STRING ${LIB_VERSION_MAJOR}.${LIB_VERSION_MINOR}.${LIB_VERSION_PATCH})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

option(BUILD_BOTH_STATIC_SHARED_LIBS OFF)

#source files set just for Android
set(openhmd_source_files
	${CMAKE_CURRENT_LIST_DIR}/src/openhmd.c
	${CMAKE_CURRENT_LIST_DIR}/src/platform-win32.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_dummy/dummy.c
	${CMAKE_CURRENT_LIST_DIR}/src/omath.c
	${CMAKE_CURRENT_LIST_DIR}/src/platform-posix.c
	${CMAKE_CURRENT_LIST_DIR}/src/fusion.c
	${CMAKE_CURRENT_LIST_DIR}/src/shaders.c
)

option(OPENHMD_DRIVER_OCULUS_RIFT "Oculus Rift DK1 and DK2" ON)
option(OPENHMD_DRIVER_DEEPOON "Deepoon E2" ON)
option(OPENHMD_DRIVER_WMR "Windows Mixed Reality" ON)
option(OPENHMD_DRIVER_PSVR "Sony PSVR" OFF)
option(OPENHMD_DRIVER_HTC_VIVE "HTC Vive" ON)
option(OPENHMD_DRIVER_NOLO "NOLO VR CV1" ON)
option(OPENHMD_DRIVER_XGVR "3Glasses HMD" ON)
option(OPENHMD_DRIVER_EXTERNAL "External sensor driver" ON)
option(OPENHMD_DRIVER_ANDROID "General Android driver" OFF)

option(OPENHMD_EXAMPLE_SIMPLE "Simple test binary" ON)
option(OPENHMD_EXAMPLE_SDL "SDL OpenGL test (outdated)" OFF)

if(OPENHMD_DRIVER_OCULUS_RIFT)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_oculus_rift/rift.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_oculus_rift/packet.c
	)
	add_definitions(-DDRIVER_OCULUS_RIFT)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_OCULUS_RIFT)

if(OPENHMD_DRIVER_DEEPOON)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_deepoon/deepoon.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_deepoon/packet.c
	)
	add_definitions(-DDRIVER_DEEPOON)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_DEEPOON)

if(OPENHMD_DRIVER_WMR)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_wmr/wmr.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_wmr/packet.c
	)
	add_definitions(-DDRIVER_WMR)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_WMR)

if(OPENHMD_DRIVER_PSVR)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_psvr/psvr.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_psvr/packet.c
	)
	add_definitions(-DDRIVER_PSVR)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_PSVR)

if(OPENHMD_DRIVER_HTC_VIVE)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_htc_vive/vive.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_htc_vive/packet.c
	#${CMAKE_CURRENT_LIST_DIR}/src/ext_deps/miniz.c
	${CMAKE_CURRENT_LIST_DIR}/src/ext_deps/nxjson.c
	)
	add_definitions(-DDRIVER_HTC_VIVE)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_HTC_VIVE)

if(OPENHMD_DRIVER_NOLO)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_nolo/nolo.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_nolo/packet.c
	)
	add_definitions(-DDRIVER_NOLO)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_NOLO)

if(OPENHMD_DRIVER_XGVR)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_3glasses/xgvr.c
	${CMAKE_CURRENT_LIST_DIR}/src/drv_3glasses/packet.c
	)
	add_definitions(-DDRIVER_XGVR)

	find_package(HIDAPI REQUIRED)
	include_directories(${HIDAPI_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${HIDAPI_LIBRARIES})
endif(OPENHMD_DRIVER_XGVR)

if (OPENHMD_DRIVER_EXTERNAL)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_external/external.c
	)
	add_definitions(-DDRIVER_EXTERNAL)
endif(OPENHMD_DRIVER_EXTERNAL)

if (OPENHMD_DRIVER_ANDROID)
	set(openhmd_source_files ${openhmd_source_files}
	${CMAKE_CURRENT_LIST_DIR}/src/drv_android/android.c
	)
	add_definitions(-DDRIVER_ANDROID)
endif(OPENHMD_DRIVER_ANDROID)

if (OPENHMD_EXAMPLE_SIMPLE)
	add_subdirectory(./examples/simple)
endif(OPENHMD_EXAMPLE_SIMPLE)

if (OPENHMD_EXAMPLE_SDL)
	find_package(SDL2 REQUIRED)
	find_package(GLEW REQUIRED)
	find_package(OpenGL REQUIRED)
	add_subdirectory(./examples/opengl)
endif (OPENHMD_EXAMPLE_SDL)

set(TARGETS "")

if (BUILD_BOTH_STATIC_SHARED_LIBS)

	# Shared
	add_library(openhmd-shared SHARED ${openhmd_source_files})
	set_target_properties(openhmd-shared PROPERTIES OUTPUT_NAME openhmd CLEAN_DIRECT_OUTPUT 1)

	# Static
	add_library(openhmd-static STATIC ${openhmd_source_files})
	set_target_properties(openhmd-static PROPERTIES OUTPUT_NAME openhmd CLEAN_DIRECT_OUTPUT 1)

	# Alias needed to compile examples
	add_library(openhmd ALIAS openhmd-shared)

	set(TARGETS "openhmd-shared" "openhmd-static")

else ()

	# Static or Shared
	add_library(openhmd ${openhmd_source_files})

	export(TARGETS openhmd FILE openhmd-config.cmake)

	set(TARGETS "openhmd")

endif ()

foreach(target ${TARGETS})

	set_target_properties(${target} PROPERTIES VERSION ${LIB_VERSION_STRING} SOVERSION ${LIB_VERSION_MAJOR})
	target_include_directories(${target} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
	target_link_libraries(${target} ${LIBS})
	if (UNIX AND NOT APPLE)
		target_link_libraries(${target} rt)
	endif()
	if (UNIX)
		target_link_libraries(${target} pthread)
	endif (UNIX)

	get_target_property(target_type ${target} TYPE)
	if (target_type STREQUAL "STATIC_LIBRARY")
	    target_compile_definitions(${target} PUBLIC -DOHMD_STATIC)
	endif()

endforeach(target)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/pkg-config/openhmd.pc.cmakein"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
)

install(TARGETS ${TARGETS} DESTINATION lib)
install(FILES include/openhmd.h DESTINATION include)
install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc"
        DESTINATION lib/pkgconfig)

=== meson_options.txt ===
option(
	'examples',
	type: 'array',
	choices: [
		'simple',
		'opengl',
		'',
	],
	value: [
		'simple',
	],
)

option(
	'drivers',
	type: 'array',
	choices: [
		'rift',
		'deepoon',
		#'psvr', disabled for 0.3
		'vive',
		'nolo',
		'wmr',
		'xgvr',
		'external',
		'android',
	],
	value: [
		'rift',
		'deepoon',
		#'psvr', disabled for 0.3
		'vive',
		'nolo',
		'wmr',
		'xgvr',
		'external',
	],
)

option(
	'hidapi',
	type: 'combo',
	choices: [
		'auto',
		'libusb',
		'hidraw'
	],
	value: 'auto',
)

=== examples/opengl/CMakeLists.txt ===
project (openglexample C)
include_directories(${CMAKE_BINARY_DIR}/include ${SDL2_INCLUDE_DIR} ${GLEW_INCLUDE_DIRS} ${OPENGL_INCLUDE_DIR})
link_directories(${CMAKE_BINARY_DIR})
add_executable(openglexample gl.c main.c)
target_link_libraries(openglexample PRIVATE openhmd m ${SDL2_LIBRARY} ${GLEW_LIBRARIES} ${OPENGL_LIBRARIES})

=== examples/simple/CMakeLists.txt ===
project (simple C)
include_directories(${CMAKE_BINARY_DIR}/include)
link_directories(${CMAKE_BINARY_DIR})
add_executable(simple simple.c)
target_link_libraries(simple PRIVATE openhmd)
if (UNIX)
    target_link_libraries(simple PRIVATE m)
endif()

=== debian/changelog ===
libopenhmd (0.3.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop unnecessary build dependency on SDL1 (Closes: #1038100)
  * Recommends "xr-hardware" for udev rules (Closes: #955424)
  * Rules-Requires-Root: no
  * Update standards version to 4.6.2, no further changes needed.

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + libopenhmd-dev, libopenhmd0: Add Multi-Arch: same. (Closes: #988247)
  * Add upstream metadata
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.

 -- Alexandre Detiste <tchet@debian.org>  Tue, 05 Dec 2023 23:44:31 +0100

libopenhmd (0.3.0-1) unstable; urgency=medium

  * New upstream version 0.3.0
  * Bump Standards-Versions to 4.4.0 (from 4.2.1)
  * Remove Autoconf-do-not-hard-code-the-hidapi-dependecy-in-the-pk patch

 -- Emmanuel Arias <emmanuelarias30@gmail.com>  Mon, 05 Aug 2019 19:35:43 +0000

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,22 @@
 Maintainer: Emmanuel Arias <emmanuelarias30@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 11),
-               libgl1-mesa-dev | libgl-dev,
+Build-Depends: debhelper-compat (= 13),
+               libgl-dev,
                libglew-dev,
                libhidapi-dev,
-               libsdl1.2-dev
-Standards-Version: 4.2.1
+               pkgconf
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/libopenhmd
 Vcs-Git: https://salsa.debian.org/debian/libopenhmd.git -b master
 Homepage: http://openhmd.net/
+Rules-Requires-Root: no
 
 Package: libopenhmd0
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: API and drivers for immersive technology (shared library)
  OpenHMD aims to provide a Free and Open Source API and drivers for
  immersive technology, such as head mounted displays with built in head
@@ -29,6 +31,8 @@
 Depends: libhidapi-dev,
          libopenhmd0 (= ${binary:Version}),
          ${misc:Depends}
+Recommends: xr-hardware
+Multi-Arch: same
 Description: API and drivers for immersive technology (development files)
  OpenHMD aims to provide a Free and Open Source API and drivers for
  immersive technology, such as head mounted displays with built in head

=== debian/rules ===
--- 
+++ 
@@ -17,5 +17,4 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- --enable-openglexample
-
+	dh_auto_configure -- --enable-static=no

=== debian/tests/control ===
Tests: build
Restrictions: superficial
Depends: build-essential, libopenhmd-dev, pkgconf

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libopenhmd_$1.tar.gz%" \
   https://github.com/OpenHMD/OpenHMD/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
